/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package bancopessoas;
import java.io.*; 
import java.util.*;
import org.jdom.*;
import org.jdom.input.*; 
import org.jdom.output.*;


/**
 * Esta classe foi implementada com métodos estáticos, por questões de simplicidade,
 * dada a natureza do propósito da mesma e o deadline bastante apertado. Por isso, é muito
 * pouco usado aqui o conceito de Orientação a Objetos envolvendo a classe Main.
 * Contudo, orientação a objetos foi largamente utilizada na chamada a métodos das classes
 * da API JDOM.
 * @author Rodolfo
 */
public class Main { 
    
    /**
     * Método que serve para ler o que está armazenado em um arquivo xml
     * @throws org.jdom.JDOMException
     * @throws java.io.IOException
     */
      
   public static void ler() throws JDOMException, IOException {  
        File f = new File("banco.xml");  
          
        SAXBuilder sb = new SAXBuilder();  
          
        Document d = sb.build(f);  
          
        Element banco = d.getRootElement();  
          
        List elements = banco.getChildren();  
        Iterator i = elements.iterator();  
          
        while(i.hasNext()) {  
            Element element = (Element)i.next();  
            System.out.println("CPF: " + element.getAttributeValue("CPF"));  
            //System.out.println("Prioridade: " + element.getAttributeValue("prioridade"));  
            System.out.println("Nome: " + element.getChildText("nome")); 
            System.out.println("Idade: " + element.getChildText("idade"));  
        }  
    }  
   
   public static void apagar(String cpf_) throws JDOMException, IOException {
        File f = new File("banco.xml");  
          
        SAXBuilder sb = new SAXBuilder();  
          
        Document d = sb.build(f);  
          
        Element banco = d.getRootElement();  
          
        List elements = banco.getChildren();  
        Iterator i = elements.iterator();  
          
        while(i.hasNext()) {  
            Element element = (Element)i.next();
            if(  cpf_.equalsIgnoreCase(element.getAttributeValue("CPF"))   ) {
                escrever("","","");
                System.out.println("remocao com sucesso");
            } 
            else {
                System.out.println("cpf nao encontrado");
            }
        } 
   }
   
   /**
    * Método que, dado um CPF, ele verifica se o mesmo existe no arquivo xml
    * @param cpf_
    * @return
    * @throws org.jdom.JDOMException
    * @throws java.io.IOException
    */
   public static boolean existe(String cpf_) throws JDOMException, IOException {
       boolean retorno = false;
       File f = new File("banco.xml");  
          
        SAXBuilder sb = new SAXBuilder();  
          
        Document d = sb.build(f);  
          
        Element banco = d.getRootElement();  
          
        List elements = banco.getChildren();  
        Iterator i = elements.iterator();  
          
        while(i.hasNext()) {  
            Element element = (Element)i.next();
            if(  cpf_.equalsIgnoreCase(element.getAttributeValue("CPF"))   ) {
                retorno = true;
                break;
            } 
            else {
                retorno = false;
            }
        }     
       return retorno;
   }   
      
    /**
     * Método que serve para se escrever os dados da pessoa num arquivo xml
     * @param n
     * @param i
     * @param cpf_
     */ 
    public static void escrever(String n, String i, String cpf_) {  
        
        Element banco = new Element("banco");
        Element pessoa = new Element("pessoa");  
        Element nome = new Element("nome");  
        Element idade = new Element("idade");  
        
        pessoa.setAttribute("CPF", cpf_);
        
        nome.setText(n);  
        idade.setText(i);   
          
        pessoa.addContent(nome);
        pessoa.addContent(idade);
        
        banco.addContent(pessoa);
          
        Document doc = new Document();  
        doc.setRootElement(banco);  
          
        try {  
            Writer out = new BufferedWriter(new OutputStreamWriter(  
                new FileOutputStream("banco.xml"), "UTF8"));  
              
            XMLOutputter xout = new XMLOutputter();  
            xout.output(doc,out);  
              
            //System.out.println("Dados inseridos com sucesso!");  
        } catch (UnsupportedEncodingException e) {  
            e.printStackTrace();  
        } catch (IOException e) {  
            e.printStackTrace();  
        }  
    }  
      
    /** 
     * main - execução do programa
     * @param args the command line arguments 
     */  
    public static void main(String[] args) throws IOException, JDOMException {  
        String opcao = "";  
        String nome, idade, cpf;  
          
        System.out.println("--Banco de Dados de Pessoas--");  
        System.out.println("Opções:");  
        System.out.println("1 - Criar o XML");  
        System.out.println("2 - Ler o XML");  
        System.out.println("3 - Apagar Dados do XML");
        System.out.println("4 - Atualizar Dados do XML");
        System.out.println("5 - Sair");
        System.out.println("-----------------");  
          
        do {  
            System.out.print("\nDigite a opção: ");  
            BufferedReader in = new BufferedReader(new InputStreamReader(System.in));  
            opcao = in.readLine();  
          
            if (opcao.equals("1")) {  
                System.out.println("-----------------");  
                System.out.print("Informe nome da pessoa: ");  
                in = new BufferedReader(new InputStreamReader(System.in));  
                nome = in.readLine();  
  
                System.out.print("Informe idade: ");  
                in = new BufferedReader(new InputStreamReader(System.in));  
                idade = in.readLine();  
  
                System.out.print("Informe cpf: ");  
                in = new BufferedReader(new InputStreamReader(System.in));  
                cpf = in.readLine();  
  
                escrever(nome, idade,cpf);  
                System.out.println("Dados inseridos com sucesso!");
            } else if (opcao.equals("2")) {  
                ler();  
            } else if (opcao.equals("3")) {
                System.out.print("Informe cpf: ");  
                in = new BufferedReader(new InputStreamReader(System.in));  
                cpf = in.readLine();  
                apagar(cpf);
            } else if (opcao.equals("4")) {
                System.out.print("Informe cpf: ");  
                in = new BufferedReader(new InputStreamReader(System.in));  
                cpf = in.readLine();
                if ( existe (cpf) ) {
                    System.out.print("Informe nome da pessoa: ");  
                    in = new BufferedReader(new InputStreamReader(System.in));  
                    nome = in.readLine();  
  
                    System.out.print("Informe idade: ");  
                    in = new BufferedReader(new InputStreamReader(System.in));  
                    idade = in.readLine();
                    escrever(nome,idade,cpf);
                    System.out.println("Dados atualizados com sucesso!");
                }
                
            } else if (opcao.equals("5")) {  
                System.out.println("Saindo...");  
            } else {  
                System.out.println("Opção Inválida!!!!!");  
            }  
        } while(!opcao.equals("5"));  
    }  
}
